/*
bhoooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooowo

 */
#include <stdio.h>      //printf, scanf 
#include <sys/wait.h>   //waitpid
#include <stdlib.h>     //rand, exit 
#include <unistd.h>     //fork, getpid, getppid, sleep

#define DIM 30
#define MAX_NUMERO 20

int main(int argc, char* argv[])  //argv=[fork_multipli,6]
{
    int i, num_figli=3, v[DIM], c, d, s=0;
    if (argc>1)
        num_figli = atoi(argv[1]);
    printf ("i figli sono : %d, \n", num_figli);
    for(i=0; i<DIM; i++)
    {
        v[i]=rand() % MAX_NUMERO;
        printf ("%d-", v[i]);
    }

    d=DIM/num_figli;
    printf ("\nInserisci il numero da cercare: ");
    scanf("%d", &c);
    printf ("\n numero da trovare: %d\n", c);
    pid_t pid[num_figli];

    for(i=0; i<num_figli; i++)
    {
        if ((pid[i] = fork()) < 0)
        {
            perror("Errore nella fork().\n");
            exit(EXIT_FAILURE);
        }
        if(pid[i]== 0) {
            // hai già impostato s, non deve tornare a 0 con ogni ciclo
            for(; s<d; s++){
                if(v[s]==c){
                    printf("%d figlio di %d: ha trovato %d, all'indice %d. il figlio e' il numero %d\n", getpid(), getppid(), c, s, i);
                    exit(s);
                }
            }
            exit(EXIT_FAILURE);
        }
        s=s+10;
        d=d+10;
    }

    //riprendo a gestire il flusso del padre
    int x;
    do {
        wait(&x);
        x = WEXITSTATUS(x);
    } while(x == EXIT_FAILURE);
    printf("consegnato ad indice %d\n", x);
    return EXIT_SUCCESS;
}
